"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useConfiguredStores = exports.configureContextStore = exports.initMFProviders = exports.useRootStoreContext = exports.useEmpStoreContext = exports.useMfContext = exports.useAppStoreContext = exports.AppProvider = exports._appStoreContext = exports.AppStore = exports.Context = void 0;
const inversify_1 = require("inversify");
const react_1 = __importStar(require("react"));
const __1 = require("..");
function Context(store) {
    return react_1.default.createContext(store || null);
}
exports.Context = Context;
exports.AppStore = ((store) => () => store)((0, __1.createAppStores)());
exports._appStoreContext = ((context) => () => context)(Context((0, exports.AppStore)()));
exports.AppProvider = ((AppContext, appStore) => (_a) => {
    var props = __rest(_a, []);
    return react_1.default.createElement(AppContext.Provider, { value: appStore() }, props.children);
})((0, exports._appStoreContext)(), exports.AppStore);
function useAppStoreContext() {
    const stores = react_1.default.useContext((0, exports._appStoreContext)());
    if (!stores) {
        throw new Error(__1.ERR.BEFORE_INIT);
    }
    return stores;
}
exports.useAppStoreContext = useAppStoreContext;
function useMfContext() {
    const context = useAppStoreContext();
    return Object.assign(Object.assign({}, context.employeeStore.init()), context.rootStore.init());
}
exports.useMfContext = useMfContext;
const useEmpStoreContext = () => useAppStoreContext().employeeStore;
exports.useEmpStoreContext = useEmpStoreContext;
const useRootStoreContext = () => useAppStoreContext().rootStore;
exports.useRootStoreContext = useRootStoreContext;
const initMFProviders = (provider) => (0, exports.AppStore)().employeeStore.inject(provider);
exports.initMFProviders = initMFProviders;
function configureContextStore(mfStoreCb) {
    const generalContextStore = (0, exports.AppStore)().rootStore;
    if (!(generalContextStore === null || generalContextStore === void 0 ? void 0 : generalContextStore.rootContainer)) {
        console.error(__1.ERR.CONTEXT);
    }
    const container = new inversify_1.Container({
        defaultScope: 'Singleton',
        autoBindInjectable: true
    });
    container.parent = generalContextStore.rootContainer;
    return Object.assign(Object.assign({}, generalContextStore.init()), mfStoreCb(container));
}
exports.configureContextStore = configureContextStore;
function useConfiguredStores(configuredContext) {
    const context = (0, react_1.useContext)(configuredContext);
    if (!context) {
        console.error(__1.ERR.BEFORE_INIT);
    }
    return context;
}
exports.useConfiguredStores = useConfiguredStores;
