var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { inject, injectable } from "inversify";
import axios from "axios";
import { isAxiosError, MF_TYPES, Token, } from "../..";
let Middleware = class Middleware {
    constructor(_logger, _token) {
        this._logger = _logger;
        this._token = _token;
        this._promise = Promise;
        this.client = axios.create({ baseURL: "/api", timeout: 10000 });
        this.client.interceptors.request.use(this.requestMiddleware.bind(this));
        this.client.interceptors.response.use(this.responseMiddleware.bind(this), this.errorMiddleware.bind(this));
    }
    requestMiddleware(config) {
        var _a, _b;
        if (!config.url) {
            return config;
        }
        let pathname = config.url;
        Object.entries(config.urlParams || {}).forEach(([k, v]) => {
            pathname = pathname.replace(`:${k}`, encodeURIComponent(v));
        });
        const headers = Object.create(config.headers || {});
        headers.Authorization = (_b = (_a = config.headers) === null || _a === void 0 ? void 0 : _a.Authorization) !== null && _b !== void 0 ? _b : `Bearer ${this._token.token}`;
        return Object.assign(Object.assign({}, config), { url: pathname, headers });
    }
    responseMiddleware(response) {
        return this._promise.resolve(response);
    }
    errorMiddleware(error) {
        var _a, _b, _c, _d;
        if (isAxiosError(error) && error.isAxiosError) {
            if (((_a = error.response) === null || _a === void 0 ? void 0 : _a.status) === 408) {
                this._logger.toError((_c = (_b = error.config) === null || _b === void 0 ? void 0 : _b.url) !== null && _c !== void 0 ? _c : "", "Timeout exceeded");
            }
            else if (((_d = error.response) === null || _d === void 0 ? void 0 : _d.status) === 401) {
                this._token.expired = true;
            }
        }
        else {
            this._logger.toNotify("error", "Unknown error", "Unknown");
        }
        return this._promise.reject(error);
    }
};
Middleware = __decorate([
    injectable(),
    __param(0, inject(MF_TYPES.ILogger)),
    __param(1, inject(MF_TYPES.Token)),
    __metadata("design:paramtypes", [Object, Token])
], Middleware);
export { Middleware };
