import { render, renderHook } from "@testing-library/react";
import React from "react";
import { AppProvider, AppStore, useMfContext } from '../src';
const AppContext = () => (React.createElement(AppProvider, null,
    React.createElement("div", null, "Test")));
describe("Context", () => {
    describe("Provider", () => {
        it("AppProvider should render successfully", () => {
            const { baseElement } = render(React.createElement(AppContext, null));
            expect(baseElement).toMatchSnapshot();
            expect(baseElement).toBeTruthy();
        });
    });
    describe("AppStore", () => {
        it("Stores must be initialized correctly", () => {
            const { current } = renderHook(useMfContext).result;
            expect(current).toMatchObject(AppStore().rootStore.init());
        });
    });
});
